diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/topology-read/examples/topology-example-sim.cc ns-3.46/src/topology-read/examples/topology-example-sim.cc
--- ns-3.45/src/topology-read/examples/topology-example-sim.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/topology-read/examples/topology-example-sim.cc	2025-10-01 18:46:32.000000000 -0700
@@ -27,13 +27,13 @@
  * Example of TopologyReader: read in a topology in a specified format.
  *
  * This example can be used with the following parameters:
- *   - <tt>--format=Inet --input=src/topology-read/examples/Inet_small_toposample.txt</tt>
- *   - <tt>--format=Inet --input=src/topology-read/examples/Inet_toposample.txt</tt>
- *   - <tt>--format=Orbis --input=src/topology-read/examples/Orbis_toposample.txt</tt>
- *   - <tt>--format=Rocket
- *     --input=src/topology-read/examples/RocketFuel_sample_4755.r0.cch_maps.txt</tt>
- *   - <tt>--format=Rocket
- *     --input=src/topology-read/examples/RocketFuel_toposample_1239_weights.txt</tt>
+ *   - ``--format=Inet --input=src/topology-read/examples/Inet_small_toposample.txt``
+ *   - ``--format=Inet --input=src/topology-read/examples/Inet_toposample.txt``
+ *   - ``--format=Orbis --input=src/topology-read/examples/Orbis_toposample.txt``
+ *   - ``--format=Rocket
+ *     --input=src/topology-read/examples/RocketFuel_sample_4755.r0.cch_maps.txt``
+ *   - ``--format=Rocket
+ *     --input=src/topology-read/examples/RocketFuel_toposample_1239_weights.txt``
  */
 
 using namespace ns3;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/uan/helper/uan-helper.cc ns-3.46/src/uan/helper/uan-helper.cc
--- ns-3.45/src/uan/helper/uan-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/uan/helper/uan-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -195,4 +195,4 @@
     return (currentStream - stream);
 }
 
-} // end namespace ns3
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/uan/helper/uan-helper.h ns-3.46/src/uan/helper/uan-helper.h
--- ns-3.45/src/uan/helper/uan-helper.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/uan/helper/uan-helper.h	2025-10-01 18:46:32.000000000 -0700
@@ -202,6 +202,6 @@
     m_transducer = ObjectFactory(type, std::forward<Ts>(args)...);
 }
 
-} // end namespace ns3
+} // namespace ns3
 
 #endif /* UAN_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/uan/model/uan-phy-dual.cc ns-3.46/src/uan/model/uan-phy-dual.cc
--- ns-3.45/src/uan/model/uan-phy-dual.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/uan/model/uan-phy-dual.cc	2025-10-01 18:46:32.000000000 -0700
@@ -226,7 +226,7 @@
                             MakeTraceSourceAccessor(&UanPhyDual::m_rxOkLogger),
                             "ns3::UanPhy::TracedCallback")
             .AddTraceSource("RxError",
-                            "A packet was received unsuccessfuly.",
+                            "A packet was received unsuccessfully.",
                             MakeTraceSourceAccessor(&UanPhyDual::m_rxErrLogger),
                             "ns3::UanPhy::TracedCallback")
             .AddTraceSource("Tx",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/uan/model/uan-phy-dual.h ns-3.46/src/uan/model/uan-phy-dual.h
--- ns-3.45/src/uan/model/uan-phy-dual.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/uan/model/uan-phy-dual.h	2025-10-01 18:46:32.000000000 -0700
@@ -230,7 +230,7 @@
 
     /** A packet was received successfully. */
     ns3::TracedCallback<Ptr<const Packet>, double, UanTxMode> m_rxOkLogger;
-    /** A packet was received unsuccessfuly. */
+    /** A packet was received unsuccessfully. */
     ns3::TracedCallback<Ptr<const Packet>, double, UanTxMode> m_rxErrLogger;
     /** A packet was sent from this Phy. */
     ns3::TracedCallback<Ptr<const Packet>, double, UanTxMode> m_txLogger;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/uan/model/uan-phy-gen.cc ns-3.46/src/uan/model/uan-phy-gen.cc
--- ns-3.45/src/uan/model/uan-phy-gen.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/uan/model/uan-phy-gen.cc	2025-10-01 18:46:32.000000000 -0700
@@ -609,7 +609,7 @@
                             MakeTraceSourceAccessor(&UanPhyGen::m_rxOkLogger),
                             "ns3::UanPhy::TracedCallback")
             .AddTraceSource("RxError",
-                            "A packet was received unsuccessfuly.",
+                            "A packet was received unsuccessfully.",
                             MakeTraceSourceAccessor(&UanPhyGen::m_rxErrLogger),
                             "ns3::UanPhy::TracedCallback")
             .AddTraceSource("Tx",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/visualizer/model/pyviz.cc ns-3.46/src/visualizer/model/pyviz.cc
--- ns-3.45/src/visualizer/model/pyviz.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/visualizer/model/pyviz.cc	2025-10-01 18:46:32.000000000 -0700
@@ -154,13 +154,6 @@
     Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::PointToPointNetDevice/MacRx",
                             MakeCallback(&PyViz::TraceNetDevRxPointToPoint, this));
 
-    // WiMax
-    Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Tx",
-                            MakeCallback(&PyViz::TraceNetDevTxWimax, this));
-
-    Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Rx",
-                            MakeCallback(&PyViz::TraceNetDevRxWimax, this));
-
     // LTE
     Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::LteNetDevice/Tx",
                             MakeCallback(&PyViz::TraceNetDevTxLte, this));
@@ -631,7 +624,7 @@
     else
     {
         // NS_ASSERT (0);
-        NS_LOG_WARN("Packet has no byte tag; wimax link?");
+        NS_LOG_WARN("Packet has no byte tag");
         uid = packet->GetUid();
     }
 
@@ -797,22 +790,6 @@
 }
 
 void
-PyViz::TraceNetDevTxWimax(std::string context,
-                          Ptr<const Packet> packet,
-                          const Mac48Address& destination)
-{
-    NS_LOG_FUNCTION(context);
-    TraceNetDevTxCommon(context, packet, destination);
-}
-
-void
-PyViz::TraceNetDevRxWimax(std::string context, Ptr<const Packet> packet, const Mac48Address& source)
-{
-    NS_LOG_FUNCTION(context);
-    TraceNetDevRxCommon(context, packet, source);
-}
-
-void
 PyViz::TraceNetDevTxLte(std::string context,
                         Ptr<const Packet> packet,
                         const Mac48Address& destination)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/visualizer/model/pyviz.h ns-3.46/src/visualizer/model/pyviz.h
--- ns-3.45/src/visualizer/model/pyviz.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/visualizer/model/pyviz.h	2025-10-01 18:46:32.000000000 -0700
@@ -393,25 +393,6 @@
     void TraceNetDevRxPointToPoint(std::string context, Ptr<const Packet> packet);
 
     /**
-     * WiMax transmit trace callback function
-     * @param context the context
-     * @param packet the packet
-     * @param destination the destination MAC address
-     */
-    void TraceNetDevTxWimax(std::string context,
-                            Ptr<const Packet> packet,
-                            const Mac48Address& destination);
-    /**
-     * WiMax transmit trace callback function
-     * @param context the context
-     * @param packet the packet
-     * @param source the source MAC address
-     */
-    void TraceNetDevRxWimax(std::string context,
-                            Ptr<const Packet> packet,
-                            const Mac48Address& source);
-
-    /**
      * LTE transmit trace callback function
      * @param context the context
      * @param packet the packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/visualizer/visualizer/base.py ns-3.46/src/visualizer/visualizer/base.py
--- ns-3.45/src/visualizer/visualizer/base.py	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/visualizer/visualizer/base.py	2025-10-01 18:46:32.000000000 -0700
@@ -59,8 +59,6 @@
     ns.BridgeNetDevice: NetDeviceTraits(is_virtual=True),
     ns.LoopbackNetDevice: NetDeviceTraits(is_virtual=True, is_wireless=False),
     ns.MeshPointDevice: NetDeviceTraits(is_virtual=True),
-    ns.SubscriberStationNetDevice: NetDeviceTraits(is_wireless=True),
-    ns.BaseStationNetDevice: NetDeviceTraits(is_wireless=True),
     ns.LteUeNetDevice: NetDeviceTraits(is_wireless=True),
     ns.LteEnbNetDevice: NetDeviceTraits(is_wireless=True),
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/CMakeLists.txt ns-3.46/src/wifi/CMakeLists.txt
--- ns-3.45/src/wifi/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -14,6 +14,7 @@
     helper/wifi-radio-energy-model-helper.cc
     helper/yans-wifi-helper.cc
     helper/wifi-phy-rx-trace-helper.cc
+    helper/wifi-static-setup-helper.cc
     helper/wifi-tx-stats-helper.cc
     model/addba-extension.cc
     model/adhoc-wifi-mac.cc
@@ -137,7 +138,6 @@
     model/wifi-acknowledgment.cc
     model/wifi-assoc-manager.cc
     model/wifi-bandwidth-filter.cc
-    model/wifi-constants.cc
     model/wifi-default-ack-manager.cc
     model/wifi-default-assoc-manager.cc
     model/wifi-default-gcr-manager.cc
@@ -167,11 +167,13 @@
     model/wifi-ru.cc
     model/wifi-spectrum-phy-interface.cc
     model/wifi-spectrum-signal-parameters.cc
+    model/wifi-standard-constants.cc
     model/wifi-standards.cc
     model/wifi-tx-current-model.cc
     model/wifi-tx-parameters.cc
     model/wifi-tx-timer.cc
     model/wifi-tx-vector.cc
+    model/wifi-types.cc
     model/wifi-utils.cc
     model/yans-error-rate-model.cc
     model/yans-wifi-channel.cc
@@ -188,6 +190,7 @@
     helper/wifi-radio-energy-model-helper.h
     helper/yans-wifi-helper.h
     helper/wifi-phy-rx-trace-helper.h
+    helper/wifi-static-setup-helper.h
     helper/wifi-tx-stats-helper.h
     model/addba-extension.h
     model/adhoc-wifi-mac.h
@@ -310,7 +313,6 @@
     model/wifi-acknowledgment.h
     model/wifi-assoc-manager.h
     model/wifi-bandwidth-filter.h
-    model/wifi-constants.h
     model/wifi-default-ack-manager.h
     model/wifi-default-assoc-manager.h
     model/wifi-default-gcr-manager.h
@@ -328,6 +330,7 @@
     model/wifi-mode.h
     model/wifi-mpdu.h
     model/wifi-net-device.h
+    model/wifi-ns3-constants.h
     model/wifi-opt-field.h
     model/wifi-phy-band.h
     model/wifi-phy-common.h
@@ -346,6 +349,7 @@
     model/wifi-ru.h
     model/wifi-spectrum-phy-interface.h
     model/wifi-spectrum-signal-parameters.h
+    model/wifi-standard-constants.h
     model/wifi-standards.h
     model/wifi-tx-current-model.h
     model/wifi-tx-parameters.h
@@ -403,6 +407,8 @@
     test/wifi-retransmit-test.cc
     test/wifi-ru-allocation-test.cc
     test/wifi-channel-switching-test.cc
+    test/wifi-static-emlsr-test.cc
+    test/wifi-static-infra-bss-test.cc
     test/wifi-test.cc
     test/wifi-transmit-mask-test.cc
     test/wifi-txop-test.cc
@@ -411,4 +417,5 @@
     test/wifi-phy-mu-mimo-test.cc
     test/wifi-operating-channel-test.cc
     test/wifi-tx-stats-helper-test.cc
+  GENERATE_EXPORT_HEADER
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/doc/Makefile ns-3.46/src/wifi/doc/Makefile
--- ns-3.45/src/wifi/doc/Makefile	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/doc/Makefile	2025-10-01 18:46:32.000000000 -0700
@@ -1,7 +1,4 @@
-EPSTOPDF = epstopdf
-DIA = dia
-DOT = dot
-CONVERT = convert -density 120
+include $(CURDIR)/../../../doc/sphinx/defines.mk
 
 SOURCE = source
 FIGURES = $(SOURCE)/figures
@@ -64,16 +61,7 @@
 	$(EPSTOPDF) $< -o=$@
 	if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi
 
-
-# You can set these variables from the command line.
-SPHINXOPTS    = -W --keep-going
-SPHINXBUILD   = sphinx-build
-PAPER         =
-BUILDDIR      = build
-
 # Internal variables.
-PAPEROPT_a4     = -D latex_paper_size=a4
-PAPEROPT_letter = -D latex_paper_size=letter
 ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SOURCE)
 
 .PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/examples/wifi-bianchi.cc ns-3.46/src/wifi/examples/wifi-bianchi.cc
--- ns-3.45/src/wifi/examples/wifi-bianchi.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/examples/wifi-bianchi.cc	2025-10-01 18:46:32.000000000 -0700
@@ -69,14 +69,14 @@
 std::map<Mac48Address, uint64_t>
     packetsTransmitted; ///< Map that stores the total packets transmitted per STA
 std::map<Mac48Address, uint64_t>
-    psduFailed; ///< Map that stores the total number of unsuccessfuly received PSDUS (for which
+    psduFailed; ///< Map that stores the total number of unsuccessfully received PSDUS (for which
                 ///< the PHY header was successfully received)  per STA (including PSDUs not
                 ///< addressed to that STA)
 std::map<Mac48Address, uint64_t>
     psduSucceeded; ///< Map that stores the total number of successfully received PSDUs per STA
                    ///< (including PSDUs not addressed to that STA)
 std::map<Mac48Address, uint64_t> phyHeaderFailed; ///< Map that stores the total number of
-                                                  ///< unsuccessfuly received PHY headers per STA
+                                                  ///< unsuccessfully received PHY headers per STA
 std::map<Mac48Address, uint64_t>
     rxEventWhileTxing; ///< Map that stores the number of reception events per STA that occurred
                        ///< while PHY was already transmitting a PPDU
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/examples/wifi-manager-example.cc ns-3.46/src/wifi/examples/wifi-manager-example.cc
--- ns-3.45/src/wifi/examples/wifi-manager-example.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/examples/wifi-manager-example.cc	2025-10-01 18:46:32.000000000 -0700
@@ -746,10 +746,7 @@
     NetDeviceContainer serverDevice;
     NetDeviceContainer clientDevice;
 
-    AttributeContainerValue<
-        TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
-        ';'>
-        channelValue;
+    WifiPhy::ChannelSettingsValue channelValue;
 
     WifiMacHelper wifiMac;
     if (infrastructure)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/examples/wifi-test-interference-helper.cc ns-3.46/src/wifi/examples/wifi-test-interference-helper.cc
--- ns-3.45/src/wifi/examples/wifi-test-interference-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/examples/wifi-test-interference-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -81,8 +81,8 @@
         dBm_u txPowerLevelB;   ///< transmit power level B
         uint32_t packetSizeA;  ///< packet size A
         uint32_t packetSizeB;  ///< packet size B
-        uint16_t channelA;     ///< channel number A
-        uint16_t channelB;     ///< channel number B
+        uint8_t channelA;      ///< channel number A
+        uint8_t channelB;      ///< channel number B
         MHz_u widthA;          ///< channel width A
         MHz_u widthB;          ///< channel width B
         WifiStandard standard; ///< standard
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/helper/wifi-helper.cc ns-3.46/src/wifi/helper/wifi-helper.cc
--- ns-3.45/src/wifi/helper/wifi-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/helper/wifi-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -15,14 +15,17 @@
 #include "ns3/config.h"
 #include "ns3/eht-configuration.h"
 #include "ns3/eht-ppdu.h"
+#include "ns3/frame-capture-model.h"
 #include "ns3/he-configuration.h"
 #include "ns3/ht-configuration.h"
+#include "ns3/interference-helper.h"
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
 #include "ns3/names.h"
 #include "ns3/net-device-queue-interface.h"
 #include "ns3/obss-pd-algorithm.h"
 #include "ns3/pointer.h"
+#include "ns3/preamble-detection-model.h"
 #include "ns3/qos-txop.h"
 #include "ns3/qos-utils.h"
 #include "ns3/radiotap-header.h"
@@ -30,6 +33,7 @@
 #include "ns3/vht-configuration.h"
 #include "ns3/wifi-mac-queue.h"
 #include "ns3/wifi-mac-trailer.h"
+#include "ns3/wifi-radio-energy-model.h"
 
 #include <bit>
 #include <memory>
@@ -275,14 +279,12 @@
     }
     case PcapHelper::DLT_IEEE802_11_RADIO: {
         Ptr<Packet> p = packet->Copy();
-        RadiotapHeader header;
-        GetRadiotapHeader(header,
-                          p,
-                          channelFreqMhz,
-                          info->device->GetPhy(phyId)->GetPrimary20Index(),
-                          txVector,
-                          aMpdu,
-                          staId);
+        const auto header = GetRadiotapHeader(p,
+                                              channelFreqMhz,
+                                              info->device->GetPhy(phyId)->GetPrimary20Index(),
+                                              txVector,
+                                              aMpdu,
+                                              staId);
         p->AddHeader(header);
         file->Write(Simulator::Now(), p);
         return;
@@ -318,15 +320,13 @@
     }
     case PcapHelper::DLT_IEEE802_11_RADIO: {
         Ptr<Packet> p = packet->Copy();
-        RadiotapHeader header;
-        GetRadiotapHeader(header,
-                          p,
-                          channelFreqMhz,
-                          info->device->GetPhy(phyId)->GetPrimary20Index(),
-                          txVector,
-                          aMpdu,
-                          staId,
-                          signalNoise);
+        const auto header = GetRadiotapHeader(p,
+                                              channelFreqMhz,
+                                              info->device->GetPhy(phyId)->GetPrimary20Index(),
+                                              txVector,
+                                              aMpdu,
+                                              staId,
+                                              signalNoise);
         p->AddHeader(header);
         file->Write(Simulator::Now(), p);
         return;
@@ -336,35 +336,30 @@
     }
 }
 
-void
-WifiPhyHelper::GetRadiotapHeader(RadiotapHeader& header,
-                                 Ptr<Packet> packet,
+RadiotapHeader
+WifiPhyHelper::GetRadiotapHeader(Ptr<Packet> packet,
                                  uint16_t channelFreqMhz,
                                  uint8_t p20Index,
                                  const WifiTxVector& txVector,
                                  MpduInfo aMpdu,
                                  uint16_t staId,
-                                 SignalNoiseDbm signalNoise)
+                                 std::optional<SignalNoiseDbm> signalNoise)
 {
-    header.SetAntennaSignalPower(signalNoise.signal);
-    header.SetAntennaNoisePower(signalNoise.noise);
-    GetRadiotapHeader(header, packet, channelFreqMhz, p20Index, txVector, aMpdu, staId);
-}
+    RadiotapHeader header;
 
-void
-WifiPhyHelper::GetRadiotapHeader(RadiotapHeader& header,
-                                 Ptr<Packet> packet,
-                                 uint16_t channelFreqMhz,
-                                 uint8_t p20Index,
-                                 const WifiTxVector& txVector,
-                                 MpduInfo aMpdu,
-                                 uint16_t staId)
-{
     const auto preamble = txVector.GetPreambleType();
     const auto modClass = txVector.GetModulationClass();
     const auto channelWidth = txVector.GetChannelWidth();
     const auto gi = txVector.GetGuardInterval();
 
+    header.SetWifiHeader(IsEht(preamble) ? 2 : 1);
+
+    if (signalNoise)
+    {
+        header.SetAntennaSignalPower(signalNoise->signal);
+        header.SetAntennaNoisePower(signalNoise->noise);
+    }
+
     header.SetTsft(Simulator::Now().GetMicroSeconds());
 
     uint8_t frameFlags = RadiotapHeader::FRAME_FLAG_NONE;
@@ -815,6 +810,8 @@
         ehtFields.userInfo.push_back(userInfo);
         header.SetEhtFields(ehtFields);
     }
+
+    return header;
 }
 
 void
@@ -1301,6 +1298,7 @@
     LogComponentEnable("WifiSpectrumPhyInterface", logLevel);
     LogComponentEnable("WifiSpectrumSignalParameters", logLevel);
     LogComponentEnable("WifiSpectrumValueHelper", logLevel);
+    LogComponentEnable("WifiStaticSetupHelper", logLevel);
     LogComponentEnable("WifiTxCurrentModel", logLevel);
     LogComponentEnable("WifiTxParameters", logLevel);
     LogComponentEnable("WifiTxTimer", logLevel);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/helper/wifi-helper.h ns-3.46/src/wifi/helper/wifi-helper.h
--- ns-3.45/src/wifi/helper/wifi-helper.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/helper/wifi-helper.h	2025-10-01 18:46:32.000000000 -0700
@@ -20,6 +20,7 @@
 
 #include <functional>
 #include <map>
+#include <optional>
 #include <vector>
 
 namespace ns3
@@ -310,44 +311,25 @@
                                                     uint8_t phyId);
 
     /**
-     * Get the Radiotap header for a transmitted packet.
-     *
-     * @param header the radiotap header to be filled in
-     * @param packet the packet
-     * @param channelFreqMhz the channel frequency
-     * @param p20Index the index of the primary20 channel
-     * @param txVector the TXVECTOR
-     * @param aMpdu the A-MPDU information
-     * @param staId the STA-ID
-     */
-    static void GetRadiotapHeader(RadiotapHeader& header,
-                                  Ptr<Packet> packet,
-                                  uint16_t channelFreqMhz,
-                                  uint8_t p20Index,
-                                  const WifiTxVector& txVector,
-                                  MpduInfo aMpdu,
-                                  uint16_t staId);
-
-    /**
      * Get the Radiotap header for a received packet.
      *
-     * @param header the radiotap header to be filled in
      * @param packet the packet
      * @param channelFreqMhz the channel frequency
      * @param p20Index the index of the primary20 channel
      * @param txVector the TXVECTOR
      * @param aMpdu the A-MPDU information
      * @param staId the STA-ID
-     * @param signalNoise the rx signal and noise information
+     * @param signalNoise the rx signal and noise information (for receiver only)
+     * @return the radiotap header
      */
-    static void GetRadiotapHeader(RadiotapHeader& header,
-                                  Ptr<Packet> packet,
-                                  uint16_t channelFreqMhz,
-                                  uint8_t p20Index,
-                                  const WifiTxVector& txVector,
-                                  MpduInfo aMpdu,
-                                  uint16_t staId,
-                                  SignalNoiseDbm signalNoise);
+    static RadiotapHeader GetRadiotapHeader(
+        Ptr<Packet> packet,
+        uint16_t channelFreqMhz,
+        uint8_t p20Index,
+        const WifiTxVector& txVector,
+        MpduInfo aMpdu,
+        uint16_t staId,
+        std::optional<SignalNoiseDbm> signalNoise = std::nullopt);
 
     /**
      * @brief Enable pcap output the indicated net device.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/helper/wifi-radio-energy-model-helper.h ns-3.46/src/wifi/helper/wifi-radio-energy-model-helper.h
--- ns-3.45/src/wifi/helper/wifi-radio-energy-model-helper.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/helper/wifi-radio-energy-model-helper.h	2025-10-01 18:46:32.000000000 -0700
@@ -10,6 +10,7 @@
 #define WIFI_RADIO_ENERGY_MODEL_HELPER_H
 
 #include "ns3/energy-model-helper.h"
+#include "ns3/wifi-export.h"
 #include "ns3/wifi-radio-energy-model.h"
 
 namespace ns3
@@ -22,7 +23,7 @@
  * This installer installs WifiRadioEnergyModel for only WifiNetDevice objects.
  *
  */
-class WifiRadioEnergyModelHelper : public DeviceEnergyModelHelper
+class WIFI_EXPORT WifiRadioEnergyModelHelper : public DeviceEnergyModelHelper
 {
   public:
     /**
